import greenfoot.*;// (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;//enable list's
import java.util.ArrayList;
/**
 * MY class
 * 
 * @author Tyler Hanson 
 * @version Date edited: 12-24-2010
 */
public class Tyler  extends Actor
{
    private GreenfootImage[] image = new GreenfootImage[1];//images of player
    
    /** total health */
    static int Health = 100;//total health

    /** movement speed */
    private int Speed = 2;//how fast the player moves
    
    /** Traps from Zobbies*/
    private int trapReload;//counter so you cant place all mines at once
    private int trap;
    
    private boolean enter = true; // like trap reload exept it stops respawning forever
    
    static int totalBurgers;//total number of starting burgers
    static int totalCrim;//total criminals caught
    static int burgUsed;
    static int FreezeUsed;
    
    /** TextDisplays info from Zobbies */
    HUD health = new HUD("playerhealth");//create player health bar
    Text text  = new Text("numofburgers");//text of burgers left
    SafeArea safe = new SafeArea("safearea");//
    Text TC = new Text("numofcrims");
    GameOver go = new GameOver("go");
    Menu m1 = new Menu();

    
   static int LOCKABLE;//0 = game over, 1 = freeze only crim, 2 = normal
   static boolean freeze;
   private boolean addGO = false;
   static int totalFreeze = 0;
   
   static burger[] burgList = new burger[3];//array of 3 burgers indexed 0-2

    Criminal crim1;
    //sounds
    GreenfootSound reloadsound = new GreenfootSound("guncock.mp3");
    GreenfootSound appSound;
    GreenfootSound dropSound;
    GreenfootSound grabSound;

    public Tyler() 
    {
        //initialize variables
        Health = 100;//starting health
        totalBurgers = 0; //startiing burgers 
        totalCrim = 0;//criminals caught
        burgUsed = 0;//count of how many burgers used
        LOCKABLE = 2;//whether or not the game has ended
    }
    
    protected void addedToWorld(World world) 
    {
       getWorld().addObject(health,300,20);//HUD bar at top of screen
       getWorld().addObject(safe,300,550);//green safe area at bottom
    }
    
    public void act() 
    {
        
        if(LOCKABLE == 0)//lock if game over or pause
        {
            
        }
        else
        {
            dropinTraps();//drop method
            Movement();//movement method
            grabBurg();//get burger && arrest crim
        
        
            if(Health < 5)
            {
                Criminal.next = 0;//so that when you reset the bottom crims wont move right
                LOCKABLE = 0;
                getWorld().addObject(go,300,300);
                myWorld.gameMusic.stop();
            
                //set a different image
            }
            if (totalBurgers > 0)//trigger respawn if totalBurge
            {
                enter = true;
            }
            if (totalBurgers == 0 && enter == true )//if no more burgers then respawn
            {
                reloadsound.setVolume(75);
                if(Mute.noise == true)
                reloadsound.play();
          
                respawnB();   
                respawnB();   
                respawnB();   
          
                enter = false;
            
         
            }
        }
        if(Greenfoot.isKeyDown("space") && totalBurgers == 0)//change sound if there are no more burgers with police
        {
            if(Mute.noise == true)
            reloadsound.play();
        } 
    }
    
    public void Movement() 
    {
        if(Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("up")) 
        {//move up
            setLocation(getX(), getY() - Speed);
            setRotation(270);
        }
        if((Greenfoot.isKeyDown("s") || Greenfoot.isKeyDown("down")) && getY()<547) 
        {//move down
            setLocation(getX(), getY() + Speed);
            setRotation(90);
        }
        if(Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("left")) 
        {//move left
            setLocation(getX() - Speed, getY());
            setRotation(180);
        }
        if(Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("right")) 
        {//move right
            setLocation(getX() + Speed, getY());
            setRotation(0);
        }
    }
    
    public void dropinTraps() 
    { 
        if(totalBurgers > 0 && trapReload == 10 && Greenfoot.isKeyDown("space")&& getY()<500) //pressed space
        {//drop mine if you have one and button pressed
            //drop the burger that is not null  
            getWorld().addObject(new burger(),getX(),getY());
            for(int c=0;c<3;c++)//check for a burger thats there
            {
                if(burgList[c] != null) //if not empty then make it empty an add a pic at my location
                {
                    burgList[c] = null;//emptys index
                    c=3;
                }
            }  
            
            trapReload = 0;
            totalBurgers--;
            dropSound = new GreenfootSound("button.mp3");
            dropSound.setVolume(40);
            if(Mute.noise == true)
            dropSound.play();
            
            if(getY() < 501)//so that burgUsed will not count it in safe area
                    burgUsed++; 
        }
        else if (trapReload < 10)
        {   
            trapReload++;
        }
    }
    
       /* if( totalFreeze != 0 && trap == 20 && totalFreeze > 0 && Greenfoot.isKeyDown("z")) 
        {//drop mine if you have one and button pressed
           getWorld().addObject(new burger(),getX(),getY());
           trap = 0;
           totalFreeze--;
           FreezeUsed++;
           freeze = true;
        }
        else if (trap < 20)
        {
            trap++;
        }*/
    public void grabBurg()
    {
        burger burg = (burger)getOneIntersectingObject(burger.class);
        if(burg != null && burg.getY() > 500) 
        {
            getWorld().removeObject(burg);
            for(int a = 0;a<burgList.length;a++)//looks for which burger was eaten
            {
                if(burgList[a]==null)
                {
                    burgList[a] = new burger();//fills index
                }
            }
            
            grabSound = new GreenfootSound("button-3.mp3");
            grabSound.setVolume(50);
            if(Mute.noise == true)
            grabSound.play();
            totalBurgers++;
        }
    }
    
    /* public void respawnA()
    {
        burger Burg1 = new burger();
        getWorld().addObject(Burg1, 275, 550);
       //burgList[0] = Burg1;
    }*/
    
    public void respawnB()
    {
        burger Burg2 = new burger();
        getWorld().addObject(Burg2, 300, 550);
        //burgList[1] = Burg2;
    }
    
   /* public void respawnC()
    {
        burger Burg3 = new burger();
        getWorld().addObject(Burg3, 325, 550);
        //burgList[2] = Burg3;
    }*/
    
}
